<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/backtrace-0.3.66/src/backtrace/mod.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>mod.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../../storage.js"></script><script defer src="../../../source-script.js"></script><script defer src="../../../source-files.js"></script><script defer src="../../../main.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../../backtrace/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../../backtrace/index.html"><div class="logo-container"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../../backtrace/index.html"><img class="rust-logo" src="../../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">core::ffi::c_void</span>;
<span class="kw">use</span> <span class="ident">core::fmt</span>;

<span class="doccomment">/// Inspects the current call-stack, passing all active frames into the closure</span>
<span class="doccomment">/// provided to calculate a stack trace.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This function is the workhorse of this library in calculating the stack</span>
<span class="doccomment">/// traces for a program. The given closure `cb` is yielded instances of a</span>
<span class="doccomment">/// `Frame` which represent information about that call frame on the stack. The</span>
<span class="doccomment">/// closure is yielded frames in a top-down fashion (most recently called</span>
<span class="doccomment">/// functions first).</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The closure&#39;s return value is an indication of whether the backtrace should</span>
<span class="doccomment">/// continue. A return value of `false` will terminate the backtrace and return</span>
<span class="doccomment">/// immediately.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Once a `Frame` is acquired you will likely want to call `backtrace::resolve`</span>
<span class="doccomment">/// to convert the `ip` (instruction pointer) or symbol address to a `Symbol`</span>
<span class="doccomment">/// through which the name and/or filename/line number can be learned.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Note that this is a relatively low-level function and if you&#39;d like to, for</span>
<span class="doccomment">/// example, capture a backtrace to be inspected later, then the `Backtrace`</span>
<span class="doccomment">/// type may be more appropriate.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Required features</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This function requires the `std` feature of the `backtrace` crate to be</span>
<span class="doccomment">/// enabled, and the `std` feature is enabled by default.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Panics</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This function strives to never panic, but if the `cb` provided panics then</span>
<span class="doccomment">/// some platforms will force a double panic to abort the process. Some</span>
<span class="doccomment">/// platforms use a C library which internally uses callbacks which cannot be</span>
<span class="doccomment">/// unwound through, so panicking from `cb` may trigger a process abort.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Example</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// extern crate backtrace;</span>
<span class="doccomment">///</span>
<span class="doccomment">/// fn main() {</span>
<span class="doccomment">///     backtrace::trace(|frame| {</span>
<span class="doccomment">///         // ...</span>
<span class="doccomment">///</span>
<span class="doccomment">///         true // continue the backtrace</span>
<span class="doccomment">///     });</span>
<span class="doccomment">/// }</span>
<span class="doccomment">/// ```</span>
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;std&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">trace</span><span class="op">&lt;</span><span class="ident">F</span>: <span class="ident">FnMut</span>(<span class="kw-2">&amp;</span><span class="ident">Frame</span>) -&gt; <span class="ident">bool</span><span class="op">&gt;</span>(<span class="ident">cb</span>: <span class="ident">F</span>) {
    <span class="kw">let</span> <span class="ident">_guard</span> <span class="op">=</span> <span class="ident"><span class="kw">crate</span>::lock::lock</span>();
    <span class="kw">unsafe</span> { <span class="ident">trace_unsynchronized</span>(<span class="ident">cb</span>) }
}

<span class="doccomment">/// Same as `trace`, only unsafe as it&#39;s unsynchronized.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This function does not have synchronization guarantees but is available</span>
<span class="doccomment">/// when the `std` feature of this crate isn&#39;t compiled in. See the `trace`</span>
<span class="doccomment">/// function for more documentation and examples.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Panics</span>
<span class="doccomment">///</span>
<span class="doccomment">/// See information on `trace` for caveats on `cb` panicking.</span>
<span class="kw">pub</span> <span class="kw">unsafe</span> <span class="kw">fn</span> <span class="ident">trace_unsynchronized</span><span class="op">&lt;</span><span class="ident">F</span>: <span class="ident">FnMut</span>(<span class="kw-2">&amp;</span><span class="ident">Frame</span>) -&gt; <span class="ident">bool</span><span class="op">&gt;</span>(<span class="kw-2">mut</span> <span class="ident">cb</span>: <span class="ident">F</span>) {
    <span class="ident">trace_imp</span>(<span class="kw-2">&amp;mut</span> <span class="ident">cb</span>)
}

<span class="doccomment">/// A trait representing one frame of a backtrace, yielded to the `trace`</span>
<span class="doccomment">/// function of this crate.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The tracing function&#39;s closure will be yielded frames, and the frame is</span>
<span class="doccomment">/// virtually dispatched as the underlying implementation is not always known</span>
<span class="doccomment">/// until runtime.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Frame</span> {
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="ident">inner</span>: <span class="ident">FrameImp</span>,
}

<span class="kw">impl</span> <span class="ident">Frame</span> {
    <span class="doccomment">/// Returns the current instruction pointer of this frame.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This is normally the next instruction to execute in the frame, but not</span>
    <span class="doccomment">/// all implementations list this with 100% accuracy (but it&#39;s generally</span>
    <span class="doccomment">/// pretty close).</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// It is recommended to pass this value to `backtrace::resolve` to turn it</span>
    <span class="doccomment">/// into a symbol name.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">ip</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">*mut</span> <span class="ident">c_void</span> {
        <span class="self">self</span>.<span class="ident">inner</span>.<span class="ident">ip</span>()
    }

    <span class="doccomment">/// Returns the current stack pointer of this frame.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// In the case that a backend cannot recover the stack pointer for this</span>
    <span class="doccomment">/// frame, a null pointer is returned.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">sp</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">*mut</span> <span class="ident">c_void</span> {
        <span class="self">self</span>.<span class="ident">inner</span>.<span class="ident">sp</span>()
    }

    <span class="doccomment">/// Returns the starting symbol address of the frame of this function.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This will attempt to rewind the instruction pointer returned by `ip` to</span>
    <span class="doccomment">/// the start of the function, returning that value. In some cases, however,</span>
    <span class="doccomment">/// backends will just return `ip` from this function.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The returned value can sometimes be used if `backtrace::resolve` failed</span>
    <span class="doccomment">/// on the `ip` given above.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">symbol_address</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">*mut</span> <span class="ident">c_void</span> {
        <span class="self">self</span>.<span class="ident">inner</span>.<span class="ident">symbol_address</span>()
    }

    <span class="doccomment">/// Returns the base address of the module to which the frame belongs.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">module_base_address</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">*mut</span> <span class="ident">c_void</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">inner</span>.<span class="ident">module_base_address</span>()
    }
}

<span class="kw">impl</span> <span class="ident">fmt::Debug</span> <span class="kw">for</span> <span class="ident">Frame</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;mut</span> <span class="ident">fmt::Formatter</span><span class="op">&lt;</span><span class="lifetime">&#39;_</span><span class="op">&gt;</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="ident">f</span>.<span class="ident">debug_struct</span>(<span class="string">&quot;Frame&quot;</span>)
            .<span class="ident">field</span>(<span class="string">&quot;ip&quot;</span>, <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">ip</span>())
            .<span class="ident">field</span>(<span class="string">&quot;symbol_address&quot;</span>, <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">symbol_address</span>())
            .<span class="ident">finish</span>()
    }
}

<span class="macro">cfg_if::cfg_if!</span> {
    <span class="comment">// This needs to come first, to ensure that</span>
    <span class="comment">// Miri takes priority over the host platform</span>
    <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">miri</span>)]</span> {
        <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">mod</span> <span class="ident">miri</span>;
        <span class="kw">use</span> <span class="ident"><span class="self">self</span>::miri::trace</span> <span class="kw">as</span> <span class="ident">trace_imp</span>;
        <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">use</span> <span class="ident"><span class="self">self</span>::miri::Frame</span> <span class="kw">as</span> <span class="ident">FrameImp</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(
        <span class="ident">any</span>(
            <span class="ident">all</span>(
                <span class="ident">unix</span>,
                <span class="ident">not</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;emscripten&quot;</span>),
                <span class="ident">not</span>(<span class="ident">all</span>(<span class="ident">target_os</span> <span class="op">=</span> <span class="string">&quot;ios&quot;</span>, <span class="ident">target_arch</span> <span class="op">=</span> <span class="string">&quot;arm&quot;</span>)),
            ),
            <span class="ident">all</span>(
                <span class="ident">target_env</span> <span class="op">=</span> <span class="string">&quot;sgx&quot;</span>,
                <span class="ident">target_vendor</span> <span class="op">=</span> <span class="string">&quot;fortanix&quot;</span>,
            ),
        )
    )]</span> {
        <span class="kw">mod</span> <span class="ident">libunwind</span>;
        <span class="kw">use</span> <span class="ident"><span class="self">self</span>::libunwind::trace</span> <span class="kw">as</span> <span class="ident">trace_imp</span>;
        <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">use</span> <span class="ident"><span class="self">self</span>::libunwind::Frame</span> <span class="kw">as</span> <span class="ident">FrameImp</span>;
    } <span class="kw">else</span> <span class="kw">if</span> <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">all</span>(<span class="ident">windows</span>, <span class="ident">not</span>(<span class="ident">target_vendor</span> <span class="op">=</span> <span class="string">&quot;uwp&quot;</span>)))]</span> {
        <span class="kw">mod</span> <span class="ident">dbghelp</span>;
        <span class="kw">use</span> <span class="ident"><span class="self">self</span>::dbghelp::trace</span> <span class="kw">as</span> <span class="ident">trace_imp</span>;
        <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">use</span> <span class="ident"><span class="self">self</span>::dbghelp::Frame</span> <span class="kw">as</span> <span class="ident">FrameImp</span>;
        <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_env</span> <span class="op">=</span> <span class="string">&quot;msvc&quot;</span>)]</span> <span class="comment">// only used in dbghelp symbolize</span>
        <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">use</span> <span class="ident"><span class="self">self</span>::dbghelp::StackFrame</span>;
    } <span class="kw">else</span> {
        <span class="kw">mod</span> <span class="ident">noop</span>;
        <span class="kw">use</span> <span class="ident"><span class="self">self</span>::noop::trace</span> <span class="kw">as</span> <span class="ident">trace_imp</span>;
        <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">use</span> <span class="ident"><span class="self">self</span>::noop::Frame</span> <span class="kw">as</span> <span class="ident">FrameImp</span>;
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="backtrace" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>